
Const count_covers% = 7
Global cover:TImage[count_covers], coverindex% = Rand(1,6)
create_covers()

Function create_covers(white_alpha% = 8)

	SetClsColor 48,48,48

	Local count%, size#, x#, y#, temp_size#

	'--- Die runde Abdeckung der vier Ecken : --------------
	Cls	
	size = ScreenSize/36.0
	x = -size
	temp_size = ScreenSize-x-x
	Repeat
		Local darker% = -48.0*x/size
		SetColor darker, darker, darker
		DrawOval x,x,temp_size,temp_size
		x:+1
		temp_size = ScreenSize-x-x
	Until x >= 0
	SetColor 0,0,0
	DrawOval 0,0,ScreenSize,ScreenSize
	cover[0] = GrabMaskedImage(ScreenSize,ScreenSize)
	
		'kleine Info zum Programmbeginn, da man nun mitunter etwas warten muss ...
		SetColor 160,140,120
		DrawText "Einen Moment bitte ... ", HalfScreen-80, HalfScreen
		Flip
		
	'--- Kreisringe : --------------------------------------
		
	size = 8
	count = HalfScreen/size/2
	x = 0
	temp_size = ScreenSize
	Cls	
	For Local i% = 0 To count
		SetColor white_alpha, white_alpha, white_alpha
		DrawOval x,x,temp_size,temp_size
		x = x + size
		temp_size = ScreenSize-x-x
		SetColor 255,255,255
		DrawOval x,x,temp_size,temp_size
		x = x + size
		temp_size = ScreenSize-x-x
	Next
	cover[1] = GrabAlphaImage(ScreenSize,ScreenSize)

	'--- Schachbrettmuster : --------------------------------
		
	size = 16
	count = ScreenSize/size
	Cls	
	For Local i% = 0 To count
		For Local j% = 0 To count
			If (i+j) Mod 2 = 0 Then
				SetColor white_alpha, white_alpha, white_alpha
			Else
				SetColor 255,255,255
			End If
			DrawRect i*size, j*size, size, size
		Next
	Next
	cover[2] = GrabAlphaImage(ScreenSize,ScreenSize)

	'--- Buchstabenmuster : --------------------------------
		
	Cls
	y = 0
	Repeat
		x = 0
		Repeat
			DrawText Chr(Rand(65,90)+32*Rand(0,1)), x, y
			x:+9
		Until x >= ScreenSize
		y:+12
	Until y >= ScreenSize
	cover[3] = GrabAlphaImage(ScreenSize,ScreenSize)
	

	'--- Kreismuster : --------------------------------

	size = 16
	count = ScreenSize/size
	temp_size = 0.9*size
	Cls
	SetColor white_alpha, white_alpha, white_alpha
	For Local i% = 0 To count
		For Local j% = 0 To count
			DrawOval i*size+1, j*size+1, temp_size, temp_size
		Next
	Next
	cover[4] = GrabAlphaImage(ScreenSize,ScreenSize)

	'--- Zahlenkreise : ----------------------------------
	
	Cls
	y = 0
	Repeat
		temp_size = HalfScreen - y
		Local angle# = 0
		Local angle_step# = ATan(9.0 / temp_size)
		Local angle_end# = 360 - 0.5*angle_step
		Repeat
			SetRotation angle+90
			DrawText Chr(Rand(48,57)), HalfScreen + temp_size * Cos(angle), HalfScreen + temp_size * Sin(angle)
			angle:+angle_step
		Until angle >= angle_end
		y:+12
	Until Abs(HalfScreen-y) =< 24
	SetRotation 0
	DrawOval HalfScreen-16, Halfscreen-16,32,32
	cover[5] = GrabAlphaImage(ScreenSize,ScreenSize)
	
	'--- Sternblende : ----------------------------------
	
	Cls
	size = 1.1*HalfScreen
	Const angle_step% = 6
	For Local angle% = 0 Until 360 Step angle_step
		DrawPoly( [HalfScreen, HalfScreen, Float(HalfScreen + size*Cos(angle)), Float(HalfScreen + size*Sin(angle)), Float(HalfScreen + size*Cos(angle+0.5*angle_step)), Float(HalfScreen + size*Sin(angle+0.5*angle_step))] )	
	Next	
	DrawOval HalfScreen-16, Halfscreen-16,32,32
	cover[6] = GrabAlphaImage(ScreenSize,ScreenSize)

	'--------------------------------------------------------

End Function

'#######################################

Function change_cover()
	Cls
	CoverIndex = CoverIndex Mod 6 + 1
End Function

