
Global brush_scale#[2], brush_rotation#[2], brush_moverotation#[2], brush_color%[2], brush_bright%[2]
brush_color = [Rand(0,191), Rand(1,2) * 16 * (1-2*Rand(0,1))]
brush_bright[0] = Rand(0,62)
If brush_bright[0] > 31 Then
	brush_bright[1] = Rand(-31,0)
Else
	brush_bright[1] = Rand(31-brush_bright[0],31)
End If

Function Painting%(full_variety@ = False, PaintingDuration# = 1000.0, PaintingIndex@ = 0, BrushIndex@ = 0)

	If full_variety = True Then
		PaintingIndex = Rand(0,4)
		BrushIndex = Rand(0,6)
		brush_color = [Rand(0,191), 64]
	Else
		brush_color[0] = (brush_color[0] + brush_color[1] + 192) Mod 192
		brush_color[1] = Rand(1,2) * 16 * (1-2*Rand(0,1))
	End If

	brush_bright[0] = Rand(0,62)
	If brush_bright[0] > 31 Then
		brush_bright[1] = Rand(-31,0)
	Else
		brush_bright[1] = Rand(31-brush_bright[0],31)
	End If
	
	Local Count_Sym%, Rotation_Sym%
	Local progress#, PaintingTime% = GlobalActualTime

	Select PaintingIndex
		
	Case 0 'zentriertes Einzelobjekt
	
		brush_rotation = [Float(Rand(0,180)), Float(Rand(-180,180))]
	
		Repeat
		
			If KeyDown(KEY_ESCAPE) Or AppTerminate() Then End

			progress = (MilliSecs() - PaintingTime) / PaintingDuration
			If progress > 1 Then Exit
			'------------------------------------------------------------------------
			SetColor 0,0,0	
			DrawImage cover[CoverIndex], HalfScreen, HalfScreen
			'------------------------------------------------------------------------
	
			Local temp_brush_color% = (brush_color[0] + progress*brush_color[1] + 192) Mod 192
			Local temp_brush_bright% = brush_bright[0] + progress*brush_bright[1]
			SetColor Red[temp_brush_color, temp_brush_bright], Green[temp_brush_color, temp_brush_bright], Blue[temp_brush_color, temp_brush_bright]
			
			Local temp_brush_scale# = 0.25 + 3.75 * Sqr(progress)
			SetScale temp_brush_scale, temp_brush_scale

			Local temp_brush_rotation# = brush_rotation[0] + progress*brush_rotation[1]
			SetRotation temp_brush_rotation

			DrawImage brush[brushindex], HalfScreen, HalfScreen
			
			'------------------------------------------------------------------------
			
			SetScale 1,1
			SetRotation 0
			SetColor 255,255,255
			DrawImage cover[0], HalfScreen, HalfScreen

			Flip
			WaitTimer(timer)

		Forever
			
	Case 1	'Randverzierung
		
		Count_Sym = Rand(4,8)
		Rotation_Sym = 360 / Count_Sym
		brush_scale[0] = 1.0 + 0.5*Rnd()
		brush_moverotation = [Float(Rand(-180,180)), Float(Rand(-45,45))]
	
		Repeat
		
			If KeyDown(KEY_ESCAPE) Or AppTerminate() Then End

			progress = (MilliSecs() - PaintingTime) / PaintingDuration
			If progress > 1 Then Exit
			'------------------------------------------------------------------------		
			SetColor 0,0,0
			DrawImage cover[CoverIndex], HalfScreen, HalfScreen
			'------------------------------------------------------------------------
	
			Local temp_brush_color% = (brush_color[0] + progress*brush_color[1] + 192) Mod 192
			Local temp_brush_bright% = brush_bright[0] + progress*brush_bright[1]
			SetColor Red[temp_brush_color, temp_brush_bright], Green[temp_brush_color, temp_brush_bright], Blue[temp_brush_color, temp_brush_bright]

			Local Special_Progress# = Sin(180*progress)

			brush_scale[1] = (2.0 - Special_Progress) * brush_scale[0]
			SetScale brush_scale[1], brush_scale[1]
			
			brush_moverotation[1] = brush_moverotation[0]
			
			For Local s% = 0 Until Count_Sym
				SetRotation brush_moverotation[1]
				DrawImage brush[brushindex], HalfScreen + (1.5 - Special_Progress) * HalfScreen * Cos(brush_moverotation[1]), HalfScreen + (1.5 - Special_Progress) * HalfScreen * Sin(brush_moverotation[1])
				brush_moverotation[1]:+Rotation_Sym
			Next
			
			'------------------------------------------------------------------------
			
			SetScale 1,1
			SetRotation 0
			SetColor 255,255,255
			DrawImage cover[0], HalfScreen, HalfScreen

			Flip
			WaitTimer(timer)

		Forever
		
	Case 2 'fest positionierte Tuppel
	
		Count_Sym = Rand(4,8)
		Rotation_Sym = 360 / Count_Sym
		brush_rotation = [Float(Rand(0,180)), Float(Rand(-180,180))]
	
		Repeat
		
			If KeyDown(KEY_ESCAPE) Or AppTerminate() Then End

			progress = (MilliSecs() - PaintingTime) / PaintingDuration
			If progress > 1 Then Exit
			'------------------------------------------------------------------------		
			SetColor 0,0,0
			DrawImage cover[CoverIndex], HalfScreen, HalfScreen
			'------------------------------------------------------------------------
	
			Local temp_brush_color% = (brush_color[0] + progress*brush_color[1] + 192) Mod 192
			Local temp_brush_bright% = brush_bright[0] + progress*brush_bright[1]
			SetColor Red[temp_brush_color, temp_brush_bright], Green[temp_brush_color, temp_brush_bright], Blue[temp_brush_color, temp_brush_bright]
			
			Local temp_brush_scale# = 0.1 + 1.15 * Sqr(progress)
			SetScale temp_brush_scale, temp_brush_scale

			Local temp_brush_rotation# = brush_rotation[0] + progress*brush_rotation[1]
			SetRotation temp_brush_rotation

			For Local s% = 0 Until Count_Sym
				brush_moverotation[1] = brush_moverotation[0]+s*Rotation_Sym
				SetRotation brush_moverotation[1]
				DrawImage brush[brushindex], HalfScreen + 0.6 * HalfScreen * Cos(brush_moverotation[1]), HalfScreen + 0.6 * HalfScreen * Sin(brush_moverotation[1])
			Next
			
			'------------------------------------------------------------------------
			
			SetScale 1,1
			SetRotation 0
			SetColor 255,255,255
			DrawImage cover[0], HalfScreen, HalfScreen

			Flip
			WaitTimer(timer)

		Forever
		
	Case 3	'auseinanderstrebende Vielfalt
	
		Count_Sym = Rand(3,12)
		Rotation_Sym = 360 / Count_Sym
		brush_scale = [0.1, 0.2 + 0.7*Float(Rnd())]
		brush_rotation = [Float(Rand(0,180)), Float(Rand(-360,360))]
		brush_moverotation = [Float(Rand(-180,180)), Float(Rand(-180,180))]
	
		Repeat
		
			If KeyDown(KEY_ESCAPE) Or AppTerminate() Then End

			progress = (MilliSecs() - PaintingTime) / PaintingDuration
			If progress > 1 Then Exit
			'------------------------------------------------------------------------		
			SetColor 0,0,0
			DrawImage cover[CoverIndex], HalfScreen, HalfScreen
			'------------------------------------------------------------------------
	
			Local temp_brush_color% = (brush_color[0] + progress*brush_color[1] + 192) Mod 192
			Local temp_brush_bright% = brush_bright[0] + progress*brush_bright[1]
			SetColor Red[temp_brush_color, temp_brush_bright], Green[temp_brush_color, temp_brush_bright], Blue[temp_brush_color, temp_brush_bright]
			
			Local temp_brush_scale# = brush_scale[0] + progress * brush_scale[1]
			SetScale temp_brush_scale, temp_brush_scale

			Local temp_brush_rotation# = brush_rotation[0] + progress*brush_rotation[1]
			SetRotation temp_brush_rotation
			
			Local temp_brush_moverotation% = brush_moverotation[0] + progress*brush_moverotation[1]
			
			For Local s% = 0 Until Count_Sym
				DrawImage brush[brushindex], HalfScreen + progress * HalfScreen * Cos(temp_brush_moverotation), HalfScreen + progress * HalfScreen * Sin(temp_brush_moverotation)
				temp_brush_moverotation:+Rotation_Sym
			Next
			'------------------------------------------------------------------------
			
			SetScale 1,1
			SetRotation 0
			SetColor 255,255,255
			DrawImage cover[0], HalfScreen, HalfScreen

			Flip
			WaitTimer(timer)

		Forever
		
	Case 4 'asymmetrische Zufallsblitze
	
		Local radius# = 0.2 + 0.6*Rnd()
		brush_scale[0] = 0.2 + 0.8*Rnd()
		brush_rotation[0] = Rand(-180,180)
		brush_bright[0] = Rand(31,62)
		Local flash_time% = PaintingTime
		Local flash_wait# = Int(PaintingDuration) / 100
		flash_wait = PaintingDuration / flash_wait

		Repeat
		
			If KeyDown(KEY_ESCAPE) Or AppTerminate() Then End

			progress = (MilliSecs() - PaintingTime) / PaintingDuration
			If progress > 1 Then Exit
			'------------------------------------------------------------------------		
			SetColor 0,0,0
			DrawImage cover[CoverIndex], HalfScreen, HalfScreen
			'------------------------------------------------------------------------
	
			Local flash_progress# = (MilliSecs() - flash_time) / flash_wait
			
			If flash_progress < 0.5 Then
				SetBlend LightBlend
				SetColor Red[brush_color[0], brush_bright[0]], Green[brush_color[0], brush_bright[0]], Blue[brush_color[0], brush_bright[0]]
				SetScale brush_scale[0], brush_scale[0]
				SetRotation brush_rotation[0]
				DrawImage brush[brushindex], HalfScreen + radius * HalfScreen * Cos(brush_rotation[0]), HalfScreen + radius * HalfScreen * Sin(brush_rotation[0])
				SetBlend AlphaBlend
			ElseIf flash_progress >= 1 Then
				radius = 0.2 + 0.6*Rnd()
				brush_scale[0] = 0.2 + 0.8*Rnd()
				brush_rotation[0] = brush_rotation[0] + Rand(90,150)
				flash_time = MilliSecs()
			End If
			
			'------------------------------------------------------------------------
			
			SetScale 1,1
			SetRotation 0
			SetColor 255,255,255
			DrawImage cover[0], HalfScreen, HalfScreen

			Flip
			WaitTimer(timer)

		Forever
	
	Default
	
	
	End Select
End Function