
	'############## WICHTIG: #################
	
	'Wer einen eigenen Script zur einer Musik erstellen moechte,
	'braucht nur direkt diesen Teil-Code ausfuehren zu lassen ...
	
	'#########################################


?Linux
Local success@ = EnableOpenALAudio()
If success = True Then success = SetAudioDriver("OpenAL")
If success = False Then
	Local drivers$[] = AudioDrivers()
	For Local d% = 0 Until Len(drivers)
		If AudioDriverExists(drivers[d]) Then success = SetAudioDriver(drivers[d])	
		If success = True Then Exit
	Next
End If	
?

Global count_beats%, beat_full_variety@[], beat_duration%[], beat_paintingIndex@[], beat_brushIndex@[]

Function Load_Script(filepath$ = "")

	If filepath = "" Then filepath = RequestFile("Skript laden", "Musik-Skriptdatei:script", False, "media/")
	If filepath = "" Then End
	
	Local Music:TSound = LoadSound(Left(filepath, Len(filepath) - Len(".script")) + ".ogg")
	If Music = Null Then
		AppTitle = "Error"
		Notify("Die vom Script verlange Sounddatei~n'" + Left(filepath, Len(filepath) - Len(".script")) + ".ogg' konnte nicht geladen werden!~nBitte lokalisieren Sie die Datei manuell.~nAnsonsten wird das Programm wird beendet.")
		Local newsoundpath$ = RequestFile("'" + Left(filepath, Len(filepath) - Len(".script")) + ".ogg' laden", "ogg-Sounddatei:ogg", False, "media/")
		If newsoundpath = "" Then End
		Music = LoadSound(newsoundpath)
		If Music = Null Then End
	End If
	
	Local stream:TStream = ReadStream(filepath)
	While Not Eof(stream)

		count_beats = ReadInt(stream)
		beat_full_variety = New Byte[count_beats]
		beat_duration = New Int[count_beats]
		beat_paintingIndex = New Byte[count_beats]
		beat_brushIndex = New Byte[count_beats]
		
		For Local b% = 0 Until count_beats
			beat_full_variety[b] = ReadByte(stream)
			beat_duration[b] = ReadInt(stream)
			beat_paintingIndex[b] = ReadByte(stream)
			beat_brushIndex[b] = ReadByte(stream)
		Next
	
	Wend
	
	CloseStream(stream)
	
	Local Channel:TChannel = PlaySound(Music)
	
End Function

Global ScriptBeatInfoList:TList = CreateList()
If PlayStart = False Then Create_Script()

Function Create_Script()

	Graphics 600,400
	
	Type TBeatInfo
		Field full_variety_info@, duration_info%, paintingIndex_info@, brushIndex_info@
		Function add(new_full_variety_info@ = False, new_duration_info%, new_paintingIndex_info@, new_brushIndex_info@)
			Local NewBeatInfo:TBeatInfo = New TBeatInfo
			NewBeatInfo.full_variety_info = new_full_variety_info
			NewBeatInfo.duration_info = new_duration_info
			NewBeatInfo.paintingIndex_info = new_paintingIndex_info
			NewBeatInfo.brushIndex_info = new_brushIndex_info
			ListAddLast(ScriptBeatInfoList, NewBeatInfo)
		End Function
	End Type
	
	Local filepath$ = RequestFile("Musik laden", "ogg-Sounddatei:ogg", False)
	If filepath = "" Then End
	Local sound:TSound = LoadSound(filepath)
	If sound = Null Then
		Notify "Die Sound-Datei '" + filepath + "'~nkonnte nicht geladen werden! Das Programm wird beendet!"
		End
	End If
	Local channel:TChannel = CueSound(sound)
	
	Local BeatInfoList:TList = CreateList()
	Local temp_full_variety_info@ = False
	Local temp_duration_info% = 1000
	Local temp_paintingIndex_info@ = 0
	Local temp_brushIndex_info@ = 0
	
	Local stream:TStream = WriteStream(Left(filepath, Len(filepath) - Len(".ogg")) + ".script")
	Local char@
	
	SetColor 200,200,200
	DrawText "Kurzinfos:", 10,20
	DrawText "Mit jeder Taste, die wird gedrueckt wird, wird die Dauer eines Beats", 10, 60
	DrawText "bzw. der Rhythmus der entsprechenden Animation festgelegt.", 10, 80
	DrawText "Zahlentasten 1 bis 5 waehlt die Art der Animation.", 10, 110
	DrawText "Zahlentasten 1 bis 5 inklusive Alt-Tasten waehlt den Pinsel:", 10, 150
	DrawText "Kreis - Quadrat - Stern - Ring - Rahmen - Dreiecksmuster - Punktmuster", 10, 170
	DrawText "Mit der Entertaste wird voller Zufall eingeschaltet.", 10, 200
	DrawText "Mit der Rueckstelltaste wird er wieder ausgeschaltet!", 10, 230
	DrawText "Mit Escape beendet!", 10, 260
	DrawText "Musik starten mit einer Taste ihrer Wahl!", 10, 300
	Flip
	
	Repeat
		char = GetChar()
		If char <> 0 Then
			FlushKeys()

			If char = 13 Then
				temp_full_variety_info = True
			ElseIf char >= 49 And char <= 55 Then
				temp_full_variety_info = False
				If KeyDown(KEY_LALT) Or KeyDown(KEY_RALT) Then
					temp_brushIndex_info = char - 49
					temp_paintingIndex_info = Rand(0,4)
				ElseIf char <= 53 Then
					temp_paintingIndex_info = char - 49
					temp_brushIndex_info = Rand(0,6)
				End If
			ElseIf char = 8 Then
				temp_full_variety_info = False	
			End If
	
			Exit		
		End If
		If char = 27 Or AppTerminate() Then End
	Forever
	
	Local time% = MilliSecs()
	ResumeChannel(channel)

	Repeat
		char = GetChar()
		If char <> 0 Then
			FlushKeys()
			
			Local new_time% = MilliSecs()
			temp_duration_info = new_time - time
			TBeatInfo.add(temp_full_variety_info, temp_duration_info, temp_paintingIndex_info, temp_brushIndex_info)
			time = new_time
			
			If char = 13 Then
				temp_full_variety_info = True
			ElseIf char >= 49 And char <= 55 Then
				temp_full_variety_info = False
				If KeyDown(KEY_LALT) Or KeyDown(KEY_RALT) Then
					temp_brushIndex_info = char - 49
					temp_paintingIndex_info = Rand(0,4)
				ElseIf char <= 53 Then
					temp_paintingIndex_info = char - 49
					temp_brushIndex_info = Rand(0,6)
				End If
			ElseIf char = 8 Then
				temp_full_variety_info = False	
			End If
					
		End If
		If AppTerminate() Then End
	Until char = 27

	WriteInt(Stream, CountList(ScriptBeatInfoList))
	For Local BeatInfo:TBeatInfo = EachIn ScriptBeatInfoList
		WriteByte(Stream, BeatInfo.full_variety_info)
		WriteInt(Stream, BeatInfo.duration_info)
		WriteByte(Stream, BeatInfo.paintingIndex_info)
		WriteByte(Stream, BeatInfo.brushIndex_info)
	Next
	CloseStream(stream)
	

End Function